using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Modelos_Listado_Filtros;
using Exferia_EntityFramework;
using Exferia_Expedientes._0_Modelos;
using Exferia_Expedientes.General;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_Expedientes._3_Vistas.Listados
{
    public class ABS_Listado_EPD_Expedientes_P_Demandado : ABS_Listado
    {
        private Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo = new Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo>();

        //Constructor
        public ABS_Listado_EPD_Expedientes_P_Demandado()
        {
            Rellenar_Columnas();
        }

        private void Rellenar_Columnas()
        {
            //id
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.id), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(true, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.id), "id", Enumerados.G_ENUM_TIPOSDATOS.LONG, true, 0, false, false, true, false, "", null));

            //codigo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.codigo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.codigo), "Código", Enumerados.G_ENUM_TIPOSDATOS.LONG_TEXT, false, 90, true, true, true, false, "", null));

            //descripcion
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.descripcion), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.descripcion), "Descripción", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 400, true, true, true, false, "", null));

            //fechaAlta
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.fechaAlta), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.fechaAlta), "Fecha alta", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 70, true, false, false, false, "", null));

            //fechaBaja
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.fechaBaja), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.fechaBaja), "Fecha baja", Enumerados.G_ENUM_TIPOSDATOS.DATETIME, false, 70, true, false, false, false, "", null,true));

            //colectivo
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.colectivo), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.colectivo), "Colectivo", Enumerados.G_ENUM_TIPOSDATOS.BOOLEAN, false, 70, true, false, false, false, "", null, true));

            //DemandanteDemandado
            INTERNO_Filtro_Opciones_Modelo mdl_INTERNO_Filtro_Opciones_Modelo_DEMANDANTEDEMANDADO = new INTERNO_Filtro_Opciones_Modelo();
            mdl_INTERNO_Filtro_Opciones_Modelo_DEMANDANTEDEMANDADO.MULTISELECCION = false;
            mdl_INTERNO_Filtro_Opciones_Modelo_DEMANDANTEDEMANDADO.LISTADO = new List<INTERNO_Filtro_Opciones_Listado_Modelo>();
            mdl_INTERNO_Filtro_Opciones_Modelo_DEMANDANTEDEMANDADO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables_Expedientes.G_MDL_DEMANDANTEDEMANDADO_DEMANDANTE.Descripcion, Variables_Expedientes.G_MDL_DEMANDANTEDEMANDADO_DEMANDANTE.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_DEMANDANTEDEMANDADO.LISTADO.Add(new INTERNO_Filtro_Opciones_Listado_Modelo(Variables_Expedientes.G_MDL_DEMANDANTEDEMANDADO_DEMANDADO.Descripcion, Variables_Expedientes.G_MDL_DEMANDANTEDEMANDADO_DEMANDADO.Descripcion));
            mdl_INTERNO_Filtro_Opciones_Modelo_DEMANDANTEDEMANDADO.TIPO = 1;
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.DemandanteDemandado_Texto), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.DemandanteDemandado_Texto), "Demandante/Demandado", Enumerados.G_ENUM_TIPOSDATOS.OPCIONES, false, 150, true, false, true, false, "", null, false, mdl_INTERNO_Filtro_Opciones_Modelo_DEMANDANTEDEMANDADO));

            //Asesor
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_ASESOR = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.idAsesor), nameof(EPD_Asesores), nameof(EPD_Asesores.id), nameof(EPD_Asesores.codigo), nameof(EPD_Asesores.nombre), nameof(EPD_Asesores.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.Asesor), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.Asesor), "Asesor", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_ASESOR));

            //Demandado
            INTERNO_Filtro_Relacionadas_Modelo mdl_INTERNO_Filtro_Relacionadas_Modelo_DEMANDADO = new INTERNO_Filtro_Relacionadas_Modelo(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.idDemandado), nameof(EPD_Demandados), nameof(EPD_Demandados.id), nameof(EPD_Demandados.codigo), nameof(EPD_Demandados.nombre), nameof(EPD_Demandados.fechaBorrado));
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.Demandado), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.Demandado), "Demandado", Enumerados.G_ENUM_TIPOSDATOS.RELACIONADA, false, 250, true, false, false, true, "", null, false, null, mdl_INTERNO_Filtro_Relacionadas_Modelo_DEMANDADO));

            //Actores
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.Actores), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.Actores), "Actores", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 150, true, false, true, false, "", null, false));

            //observaciones
            g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo.Add(nameof(INTERNO_EPD_Expedientes_Listado_Modelo.observaciones), new INTERNO_ABS_Listado_ColumnasDatos_Modelo(false, nameof(INTERNO_EPD_Expedientes_Listado_Modelo.observaciones), "Observaciones", Enumerados.G_ENUM_TIPOSDATOS.TEXT, false, 150, true, false, true, false, "", null));

        }

        public override List<dynamic> LISTADO()
        {
            return Registros;
        }


        public override INTERNO_OpcionesDetalle_Modelo DATOS_OPCION()
        {
            return Datos_Generales.PRV_Opciones_Buscar_Detalles(Variables.G_STR_OPCION_EPD_EXPEDIENTES);
        }

        public override string NOMBRELISTADO_ALMACENARCONFIGURACION()
        {
            return Variables.G_STR_OPCION_EPD_EXPEDIENTES + "_P_Demandado";
        }

        public override Dictionary<string, INTERNO_ABS_Listado_ColumnasDatos_Modelo> LISTADO_COLUMNAS()
        {
            return g_dct_INTERNO_ABS_Listado_ColumnasDatos_Modelo;
        }

        public override string ORDENACION_NOMBRECOLUMNA_PORDEFECTO()
        {
            return nameof(INTERNO_EPD_Expedientes_Listado_Modelo.codigo);
        }

        public override string ORDENACION_TIPO_PORDEFECTO()
        {
            return "0";
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_1()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_2()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_3()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_4()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_5()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_6()
        {
            return null;
        }

        public override INTERNO_Listado_BotonesAuxiliares_Modelo BOTONAUXILIAR_7()
        {
            return null;
        }

        public override List<INTERNO_ArbolSecundarioSeleccion_Modelo> LISTADO_ARBOLSECUNDARIOSELECCION()
        {
            return null;
        }

        public override List<INTERNO_Listado_Paginado_Filtro_Modelo> FILTRADO_PARAPAGINADO()
        {
            return null;
        }

        public override List<string> LISTADOCAMPOS_ENVIAR_A_MANTENIMIENTO()
        {
            return null;
        }
    }
}
